SystemOrganization addCategory: #'HID-Core'!

Error subclass: #HIDError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HID-Core'!

Object subclass: #HID
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HID-Core'!

HID subclass: #HIDUnix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HID-Core'!

!HIDUnix class methodsFor: 'api' stamp: 'Richo 12/7/2012 10:45'!
apiClose: device
"void HID_API_EXPORT HID_API_CALL hid_close(hid_device *device);"
	<apicall: void 'hid_close' (long) module: 'libhidapi'>
	^ self externalCallFailed! !

!HIDUnix class methodsFor: 'api' stamp: 'Richo 12/7/2012 10:37'!
apiExit
	<apicall: long 'hid_exit' () module: 'libhidapi'>
	^ self externalCallFailed! !

!HIDUnix class methodsFor: 'api' stamp: 'Richo 12/7/2012 10:36'!
apiInit	
	<apicall: long 'hid_init' () module: 'libhidapi'>
	^ self externalCallFailed! !

!HIDUnix class methodsFor: 'api' stamp: 'Richo 12/7/2012 10:45'!
apiOpen: vendorId with: productId with: serialNumber
"HID_API_EXPORT hid_device * HID_API_CALL hid_open(unsigned short vendor_id, unsigned short product_id, const wchar_t *serial_number);"
	<apicall: long 'hid_open' (ushort ushort short*) module: 'libhidapi'>
	^ self externalCallFailed! !

!HIDUnix class methodsFor: 'api' stamp: 'Richo 12/7/2012 10:45'!
apiReadTimeout: device with: buffer with: bufferSize with: timeout
"int HID_API_EXPORT HID_API_CALL hid_read_timeout(hid_device *dev, unsigned char *data, size_t length, int milliseconds);"
	<apicall: long 'hid_read_timeout' (long char* ulong long) module: 'libhidapi'>
	^ self externalCallFailed! !

!HIDUnix class methodsFor: 'api' stamp: 'Richo 12/7/2012 10:45'!
apiRead: device with: buffer with: bufferSize
"int  HID_API_EXPORT HID_API_CALL hid_read(hid_device *device, unsigned char *data, size_t length);"
	<apicall: long 'hid_read' (long char* ulong) module: 'libhidapi'>
	^ self externalCallFailed! !

!HIDUnix class methodsFor: 'api' stamp: 'Richo 12/7/2012 10:45'!
apiWrite: device with: buffer with: bufferSize
"int  HID_API_EXPORT HID_API_CALL hid_write(hid_device *device, const unsigned char *data, size_t length);"
	<apicall: long 'hid_write' (long char* ulong) module: 'libhidapi'>
	^ self externalCallFailed! !

HID subclass: #HIDWin32
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HID-Core'!

!HIDWin32 class methodsFor: 'api' stamp: 'Richo 12/7/2012 10:46'!
apiClose: device
"void HID_API_EXPORT HID_API_CALL hid_close(hid_device *device);"
	<apicall: void 'hid_close' (long) module: 'hidapi.dll'>
	^ self externalCallFailed! !

!HIDWin32 class methodsFor: 'api' stamp: 'Richo 12/7/2012 10:46'!
apiExit
	<apicall: long 'hid_exit' () module: 'hidapi.dll'>
	^ self externalCallFailed! !

!HIDWin32 class methodsFor: 'api' stamp: 'Richo 12/7/2012 10:46'!
apiInit	
	<apicall: long 'hid_init' () module: 'hidapi.dll'>
	^ self externalCallFailed! !

!HIDWin32 class methodsFor: 'api' stamp: 'Richo 12/7/2012 10:46'!
apiOpen: vendorId with: productId with: serialNumber
"HID_API_EXPORT hid_device * HID_API_CALL hid_open(unsigned short vendor_id, unsigned short product_id, const wchar_t *serial_number);"
	<apicall: long 'hid_open' (ushort ushort short*) module: 'hidapi.dll'>
	^ self externalCallFailed! !

!HIDWin32 class methodsFor: 'api' stamp: 'Richo 12/7/2012 10:46'!
apiReadTimeout: device with: buffer with: bufferSize with: timeout
"int HID_API_EXPORT HID_API_CALL hid_read_timeout(hid_device *dev, unsigned char *data, size_t length, int milliseconds);"
	<apicall: long 'hid_read_timeout' (long char* ulong long) module: 'hidapi.dll'>
	^ self externalCallFailed! !

!HIDWin32 class methodsFor: 'api' stamp: 'Richo 12/7/2012 10:46'!
apiRead: device with: buffer with: bufferSize
"int  HID_API_EXPORT HID_API_CALL hid_read(hid_device *device, unsigned char *data, size_t length);"
	<apicall: long 'hid_read' (long char* ulong) module: 'hidapi.dll'>
	^ self externalCallFailed! !

!HIDWin32 class methodsFor: 'api' stamp: 'Richo 12/7/2012 10:46'!
apiWrite: device with: buffer with: bufferSize
"int  HID_API_EXPORT HID_API_CALL hid_write(hid_device *device, const unsigned char *data, size_t length);"
	<apicall: long 'hid_write' (long char* ulong) module: 'hidapi.dll'>
	^ self externalCallFailed! !

!HID class methodsFor: 'utils' stamp: 'Richo 12/4/2012 14:04'!
close: ptr
	self apiClose: ptr.
	self apiExit = -1
		ifTrue: [^ self error: 'HID finalization error' translated]
	! !

!HID class methodsFor: 'error' stamp: 'Richo 12/5/2012 16:47'!
error: aString 
	"Throw a HIDError exception."
	^ HIDError new signal: aString! !

!HID class methodsFor: 'accessing' stamp: 'Richo 12/7/2012 10:48'!
forThisPlatform
	^ SmalltalkImage current platformName caseOf: {
		['unix'] -> [HIDUnix].
		['Win32'] -> [HIDWin32]
	} otherwise: [self error: 'Platform not supported' translated]! !

!HID class methodsFor: 'utils' stamp: 'Richo 12/4/2012 14:03'!
open: vid with: pid
	| ptr |
	self apiInit = -1
		ifTrue: [^ self error: 'HID initialization error' translated].
	ptr := self apiOpen: vid with: pid with: nil.
	ptr = 0
		ifTrue: [^ self error: 'HID opening device error' translated].
	^ ptr! !

!HID class methodsFor: 'utils' stamp: 'Richo 7/2/2014 16:01'!
read: ptr
	"Assumes a default buffer size of 8 bytes"
	^ self read: ptr into: (ByteArray new: 8)! !

!HID class methodsFor: 'utils' stamp: 'Richo 7/2/2014 15:53'!
read: ptr into: buffer
	| bufSize bytesRead |
	bufSize := buffer size.	
	bytesRead := self apiReadTimeout: ptr with: buffer with: bufSize with: 0.
	^ bytesRead caseOf: {
		[bufSize] -> [buffer].
		[0] -> [#[]].
		[-1] -> [self error: 'HID reading error' translated]
	} otherwise: [buffer copyFrom: 1 to: bytesRead]! !

!HID class methodsFor: 'utils' stamp: 'Richo 12/4/2012 15:09'!
write: ptr with: data
	| bytesWritten |
	bytesWritten := self apiWrite: ptr with: data with: data size.
	bytesWritten = -1
		ifTrue: [^ self error: 'HID writing error' translated].
	^ bytesWritten! !

Object subclass: #HIDPort
	instanceVariableNames: 'device'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HID-Core'!

!HIDPort class methodsFor: 'as yet unclassified' stamp: 'Richo 1/14/2013 17:28'!
initialize
	"
	self initialize
	"
	Smalltalk
		addToShutDownList: self
! !

!HIDPort class methodsFor: 'as yet unclassified' stamp: 'Richo 1/7/2013 13:40'!
shutDown
	self allInstancesDo: [:each | each close]! !

!HIDPort methodsFor: 'connection' stamp: 'Richo 12/7/2012 10:48'!
close
	[HID forThisPlatform close: device]
		ensure: [device := nil]! !

!HIDPort methodsFor: 'input/output' stamp: 'Richo 1/14/2013 17:30'!
nextPutAll: data
	| buf hid |
	device ifNil: [^ -1].
	hid := HID forThisPlatform.
	buf := #(0 16rB1 0 0 0 0 0 0 0) asByteArray.
	1 to: data size do: [:i |
		buf at: 3 put: (data at: i).
		[hid write: device with: buf]
			on: Error do: [^ -1]].
	^ data size
! !

!HIDPort methodsFor: 'connection' stamp: 'Richo 12/17/2012 16:44'!
openPort: portName
	('HID' match: portName) ifFalse: [^ self error: 'HID invalid port' translated].
	"First, try to open in console mode:"
	[device := HID forThisPlatform open: 16r3EB with: 16r204F]
		on: HIDError
		do: [| bootPacket |
			"Could not open. Try to open the bootloader"
			[device := HID forThisPlatform open: 16r3EB with: 16r2067]
				on: HIDError do: ["No DuinoBot found" ^ nil].
			"Bootloader found. Send reset command, so it starts the app"
			bootPacket := ByteArray new: 131 withAll: 0.
			bootPacket at: 2 put: 16rFF.
			bootPacket at: 3 put: 16rFF.
			1 second asDelay wait.
			HID forThisPlatform 
				apiWrite: device
				with: bootPacket
				with: bootPacket size.
			HID forThisPlatform close: device.
			1 second asDelay wait.
			[device := HID forThisPlatform open: 16r3EB with: 16r204F]
				on: HIDError do: ["No DuinoBot found" ^ nil]]! !

!HIDPort methodsFor: 'input/output' stamp: 'Richo 12/7/2012 10:49'!
readByteArray
	| result |
	device ifNil: [^ #() asByteArray].
	result := OrderedCollection new.
	1 to: 32 do: [:i || data |
		data := HID forThisPlatform read: device.
		(data size > 2
		and: [data first = 16rB1
		and: [data second ~= 0]])
			ifTrue: [result addAll: data allButFirst]].
	^ result asByteArray! !

!HIDPort methodsFor: 'input/output' stamp: 'Richo 12/4/2012 16:53'!
readString
	^ self readByteArray asString! !
HIDPort initialize!
